% Dfinition des structures Matlab pour TCR167PCI

maPresenceCarte = 0;



% Chargement de la DLL de gestion de la carte

addpath('C:\MATLAB');
addpath('C:\MATLAB\common');

loadlibrary mbgdevio.dll mbgdevio.h alias libIrig;

      % Test de prsence de la carte IRIG: findDevices
      maPresenceCarte = calllib('libIrig','mbg_find_devices');

      monDeviceCarte = libpointer;

      %Si ok : openDevice(0)
      if maPresenceCarte == 0
          msgbox('Carte IRIG Meinberg non dtecte !');
          exit;
      else
          monDeviceCarte = calllib('libIrig','mbg_open_device',uint32(0));
          setdatatype(monDeviceCarte, 'voidPtr', 1);
      end

      % Lecture de l'heure Haute Rsolution sur la carte
      maValeurRetour = int32(0);
      %monTempsHR = PCPS_HR_TIME_matlab ;

      % Rcupration de la structure Matlab equivalente  la structure C
      % laStructureTimeStampMatlab = libstruct('PCPS_TIME_STAMP');

      laStructTempsHRMatlab = libstruct('PCPS_HR_TIME');
      % The instruction above just creates a pointer to an object, without
      % actually allocating some memory for the object. This results in a 
      % NULL pointer which lets the system trap if is is passed to the 
      % DLL function and the driver writes some data via that pointer.
      %
      % Memory for that object is allocated if one of the members of the
      % object is set to an initial value, e.g. using the instruction below:
      laStructTempsHRMatlab.tstamp.sec = 0;
      % Now the laStructTempsHRMatlab pointer addresses some real memory, 
      % and the DLL call succeeds when the driver fills up that memory with
      % the expected data:
      maValeurRetour = calllib('libIrig','mbg_get_hr_time', get(monDeviceCarte,'value'), laStructTempsHRMatlab);

      % Now extract the timestamp from the PCPS_HR_TIME structure:
      laStructureTimeStampMatlab = libstruct('PCPS_TIME_STAMP', laStructTempsHRMatlab.tstamp);

      % Convert the binary fractions (0..0xFFFFFFFF) to microseconds
      % (0..1000000):
      laStructureTimeStampMatlab.frac = laStructureTimeStampMatlab.frac * 1000000 / hex2dec( '100000000' );

  clear('laStructTempsHRMatlab');
  clear('laStructureTimeStampMatlab');

  % Libration de la DLL
  unloadlibrary libIrig;
